with import ./network.nix;
{
  services = {
    nzbget.enable = true;

    nginx.virtualHosts.${nzbgetdomain} = {
      forceSSL = true;
      enableACME = true;
      locations."/" = {
        proxyPass = "http://localhost:6789";
        extraConfig = ''
          allow 10.0.0.0/24;
          allow 10.3.0.0/24;
          deny all;
        '';
      };
    };
  };

  networking.extraHosts = ''
    ${architect-lan} ${nzbgetdomain}
    ${architect-wg} ${nzbgetdomain}
  '';

  users.groups.media.members = ["nzbget"];
}
