{ pkgs, ...}:

with import ./network.nix;
{
  services = {
    prowlarr.enable = true;

    nginx.virtualHosts.${prowlarrdomain} = {
      forceSSL = true;
      enableACME = true;
      locations."/" = {
        proxyPass = "http://localhost:9696";
        extraConfig = ''
          allow 10.0.0.0/24;
          allow 10.3.0.0/24;
          deny all;
        '';
      };

#      locations."/api" = {
#        proxyPass = "http://127.0.0.1:9696/prowlarr/api";
#      };
#
#      locations."/Content" = {
#        proxyPass = "http://127.0.0.1:9696/prowlarr/Content";
#      };
    };
  };

  networking.extraHosts = ''
    ${architect-lan} ${prowlarrdomain}
    ${architect-wg} ${prowlarrdomain}
  '';

  users.groups.media.members = ["prowlarr"];
}
